#!/usr/bin/perl

# cgi to make batbox plots

# libraries
use FCGI; # for forms input
use CGI::Carp qw(fatalsToBrowser);
use DBI;
use Graphics::GnuplotIF;


############################### Globals ########################

# test db access and plotting stuff
my $dsn = "DBI:mysql:host=localhost;database=BBBase"; # data source name
my $dbh;	# database connection handle
my $sth;	# statement handle

my $tablenamem = "BBData"; # minutes
my $tablenameh = "BBDataHours"; # hours



my $time; # "now, in epoch-seconds"
my $data; # from submit post
my ($key,$value); # for the config hash
my %config; # config  Current (only) key is seconds
# array for options box
my @options = (' value="3600">1 hour',' value="86400">1 day',' value="604800">1 week', ' value="2592000">30 days',
' value="5184000">60 days',' value="10368000">120 days',' value="31536000">365 days',' value="63072000">730 days');
 # strings to build option list in HTML
 my %refresh = (3600 => 60, 80400=>60,604800=>756,2592000=>3240,5184000=>6480,10368000=>12960,31536000=>39420,
63072000=>790090);
my $regenerate; # update plots if set
my $request = FCGI::Request; # object wrapping CGI request

################################## Subs ##########################################
##########################
sub chkregen
{ # see if we should regenerate the plots even on normal auto-refresh
 my $lasttime = (stat('/usr/share/nginx/www/plots/Temp.png'))[9]; # modify time
 if (($time - $lasttime) > $refresh{$config{seconds}}) {$regenerate = 1;}
}
#################

sub writecnf
{
 open(CONF, "> /var/tmp/plots.cnf") or carp "Couldn't write /var/tmp/plots.cnf:$!\n";
 print CONF "$data\n";
 close CONF;
}


##################
 sub makeoptions
{
 my $line;
 my $dummy = $config{seconds};
# print "dummy:$dummy<br>\n"; 
 print '<SELECT name="seconds" size="8">';
 print "\n";
 foreach $line (@options)
 {
  print '<OPTION'; # start of an option
  if ($line =~ m/"$dummy"/) {$line=~ s/>/ selected>/;} # quotes so  sub-matches won't occur
  print "$line";
  print "</OPTION>\n"; 
 }
 print "</SELECT>\n";
}
##################

##################
sub makeplots
{ # going to be a long one here
 my $tplot; #gnuplot instance - undefs when goes out of scope
 my @raw; # from database
 my $row; # one row of query results
 my (@x,@y1,@y2,@y3,@y4); # data for plots
 my $start = $time - $config{seconds}; # compute how far back from "now" for query
 my $sum = 0;

 $dbh = DBI->connect($dsn,"cgi","") or die "Cannot connect to db server\n"; # also, some free delay time

 #print "<br>time:$time<br>\n";
 $start = "\'" . "$start" ."\'";
# print "<br>start:$start<br>\n";

 $sth = $dbh->prepare("SELECT Epoch, BatTemp, BoxTemp,ListTemp,CPUTemp FROM $tablenamem WHERE Epoch > $start"); 
 $sth->execute; 
 @raw = @{$sth->fetchall_arrayref()}; # get the entire dataset

 foreach $row (@raw) { # separate for plotting
  push @x,$row->[0]; # - 946684800); # convert linux epoch to gnuplot epoch (1-Jan-70 to 1-Jan-2000)? bad dox
  push @y1, $row->[1];
  push @y2, $row->[2];
  push @y3, $row->[3];
  push @y4, $row->[4];
 }
 $tplot = Graphics::GnuplotIF->new(title => "Temperatures", style=>"lines",xlabel=>"Time - UTC",ylabel => "Degrees F") or  die "no plot\n";
 $tplot->gnuplot_cmd ('set term png small size 800,400');
 $tplot->gnuplot_cmd("set output '/usr/share/nginx/www/plots/Temp.png'");
 $tplot->gnuplot_cmd ("set grid");
 $tplot->gnuplot_set_plot_titles("Battery","Box","Lister","CPU");
 $tplot->gnuplot_cmd("set xdata time");
 $tplot->gnuplot_cmd('set timefmt "%s"'); # picky - %s has to be in double quotes and the whole thing in single...
 $tplot->gnuplot_cmd('set xtics format "%y-%m-%d\n%H:%M"'); # see above
 $tplot->gnuplot_cmd ("set key left bottom");
 $tplot->gnuplot_plot_xy(\@x,\@y1,\@y2,\@y3,\@y4);



#### Volts
 $tplot->gnuplot_cmd("set output '/usr/share/nginx/www/plots/Volts.png'");
 $tplot->gnuplot_set_title ("Battery Voltage");
 $tplot->gnuplot_set_ylabel("Volts");
 $tplot->gnuplot_set_plot_titles("System Battery");

 $sth = $dbh->prepare("SELECT Volts FROM $tablenamem WHERE Epoch > $start"); 
 $sth->execute; 
 @raw = @{$sth->fetchall_arrayref()}; # get the entire dataset
 @y1 = (); # zero out Y array
 foreach $row (@raw) { # separate for plotting
  push @y1, $row->[0];
 }
 $tplot->gnuplot_plot_xy(\@x,\@y1);
 
# Amps
 $tplot->gnuplot_cmd("set output '/usr/share/nginx/www/plots/Amps.png'");
 $tplot->gnuplot_set_title ("Battery Amperes");
 $tplot->gnuplot_set_ylabel("Amps or Amp-Hours");
 $tplot->gnuplot_set_plot_titles("Net Amps","Amp-Hours");

 
 $sth = $dbh->prepare("SELECT Amps, AmpSeconds FROM $tablenamem WHERE Epoch > $start"); 
 $sth->execute; 
 @raw = @{$sth->fetchall_arrayref()}; # get the entire dataset
 @y1 = @y2 = (); # zero out Y arrays
 foreach $row (@raw) { # separate for plotting
  push @y1, $row->[0];
  $sum += $row->[1];
  push @y2, $sum;

 }
 $tplot->gnuplot_plot_xy(\@x,\@y1,\@y2);

#### lister pump fan PF.png
 $tplot->gnuplot_cmd("set output '/usr/share/nginx/www/plots/PF.png'");
 $tplot->gnuplot_set_title ("Lister Pump & Fan");
 $tplot->gnuplot_set_ylabel("Runtime 5 sec units");
 $tplot->gnuplot_set_plot_titles("Fan","Pump");
 $tplot->gnuplot_set_yrange (0,12); #@@@ have to do this last or figure out how to re-start autoscale for the rest of the plots
 
 $sth = $dbh->prepare("SELECT ListPump, ListFan FROM $tablenamem WHERE Epoch > $start"); 
 $sth->execute; 
 @raw = @{$sth->fetchall_arrayref()}; # get the entire dataset
 @y1 = (); # zero out Y array
 @y2 = ();
 foreach $row (@raw) { # separate for plotting
  push @y1, $row->[0];
  push @y2, $row->[1];
 }
 $tplot->gnuplot_plot_xy(\@x,\@y1,\@y2);



 $dbh->disconnect;
}
##################
sub topline
{ # current db values for a few things as numbers
# my ($Volts,$Amps,$BatTemp,$ListTemp);
 my @row;
 $dbh = DBI->connect($dsn,"cgi","") or die "Cannot connect to db server\n"; # also, some free delay time
 @row = $dbh->selectrow_array("SELECT Volts, Amps, BatTemp,ListTemp FROM $tablenamem ORDER By Epoch DESC LIMIT 1"); 
 print "<h3>Volts: $row[0] Amps: $row[1] Battery Temperature: $row[2] Lister Temperature: $row[3]</h3> <br>\n";
 $dbh->disconnect;
}

##################
sub showplots
{ # make html to show the plots
print <<ENDOFPLOTS;
<div align="left">

<img alt="Voltage" height="400" src="../plots/Volts.png" width="800" />

<img alt="Amperes" height="400" src="../plots/Amps.png" width="800" />

<img alt="Temperatures" height="400" src="../plots/Temp.png" width="800" />

<img alt="Pump Fan" height="400" src="../plots/PF.png" width="800" />

</div>
ENDOFPLOTS
print "<br>\n";
}



#<img alt="Woodstove" height="400" src="../plots/Stove.png" width="800" />



######### Main ###################################

while ($request->Accept >= 0)
{
 print "Content-type:text/html\n\n"; # get the ball rolling
 print <<EndOfHTML;
<html><head><title>BatBox Plots</title><meta http-equiv="refresh" content="60"></head>
<body style="background-image: url(../pix/angels.jpg);">
<h1>BatBox Plots</h1> 
<a href="..//index.html">BatBox Home</a><br>
EndOfHTML
# magic line for auto-refresh via GET:<meta http-equiv="refresh" content="60"></head>
$time = time(); # now, in epoch seconds

{ # closure for local $/
 local $/;
 $data = <>; # suck up any submit data
}

chomp $data;

if ($data) 
 {
  writecnf(); # user submitted length request
  $regenerate = 1; # make new plots on submit, certainly.
 } else 
 {
  if (-e "/var/tmp/plots.cnf")
  {
   open (CONF, "< /var/tmp/plots.cnf");
   $data = <CONF>;
  } else 
  {  #special case if no cnf file on ramdisk
   $data = "seconds=292000\n"; # get ready and write a .cnf file for later (one week)
   writecnf();
  }
 }
 
# have data now for our hash, however we got it
 chomp $data;
 ($key,$value) = split /=/, $data;
 $config{$key} = $value;

# generate/serve plots here
#/usr/share/nginx/www/plots ?.png

topline(); # show numeric details of some present values

chkregen(); # see if we should set $regenerate
#$regenerate = 1; # debug for now

if ($regenerate) {makeplots();}

showplots();

# create a form with submit and some stuff
 print "<FORM action=\"bboxplot.cgi\" method=\"post\"><br>\n";
 print "Plot Duration<br>\n";
 makeoptions();

 print "<INPUT type=\"submit\" value=\"plot duration\">\n</FORM><br>\n";
 print '<a href="..//index.html">BatBox Home</a><br> <p> </p>';
 print "</body></html>\n";
} # end while request
